#include <windows.h>
#include <mmsystem.h>
#include <d3d8.h>
#include <d3dx8.h>
#include <stdio.h>

#define OK				1		
#define ERR_FILEOPEN	0
#define ERR_NOANIMATION 0

struct VERTEX	//vertex structure
{
	float	x, y, z;	//location
	float   nx, ny, nz;	//normals
	float   tu, tv;		//texture coords
};

struct LVERTEX	//prelit vertex structure
{
	float x, y, z;
	DWORD dwColor;
	float tu, tv;
};

struct MD3VERTEX
{
	signed short x, y, z;
	DWORD dwColor;
	float tu, tv;
};

struct MD3FRAME
{
	DWORD FrameNum;
	IDirect3DVertexBuffer8 *lpMeshVB;
};

struct MD3MESH
{
	//Header
	char	MeshID[4];
	char	Name[68];
	DWORD	NumMeshFrames;
	DWORD	NumTexs;
	DWORD	NumVertices;
	DWORD	NumTriangles;
	DWORD	TriStart;
	DWORD	HeaderSize;
	DWORD	TexCoordsStart;
	DWORD	VertexStart;
	DWORD	MeshSize;

	long	AnimCurrentTime, AnimOldTime;
	DWORD	CurrentFrame;
	long	AnimDelta;
	bool	bPlayAnimation;
	

	DWORD	*TriIndex;
	float	*TexCoords; 
	MD3VERTEX	*Verts;
	int		MD3Texture;
	unsigned int TexID;

	MD3FRAME				*Frames;
	IDirect3DIndexBuffer8	*lpMeshIB;

	char				*TexFilePath;
	IDirect3DTexture8	**lpTexture;

	int SetFrame(DWORD Frame);
	int PlayAnimation(WORD FPS);
};

struct MD3TAG
{
	char Name[64];
	D3DVECTOR Position;
	D3DXMATRIX Rotation;
};

struct MD3BONEFRAME
{
	D3DVECTOR	MinS;
	D3DVECTOR	MaxS;
	D3DVECTOR	Position;
	float		Scale;
	char		Creator[16];
};

class CMD3FILE
{
public:
	CMD3FILE();
	~CMD3FILE();


	int Load(char *FileName, char* tPath, IDirect3DDevice8 *lpDevice, BYTE Alpha);
	int ReadMD3();
	int Render(IDirect3DDevice8 *lpDevice);
	int MakeD3DGeometry(IDirect3DDevice8 *lpDevice, BYTE Alpha);
	int PlayAnimation(WORD FPS);

	//header info
	char	IDNum[4];
	DWORD	MD3Version;
	char	FileName[68];
	char	*TexPath;
	DWORD	NumBoneFrames;
	DWORD	NumTags;
	DWORD	NumMeshes;
	DWORD	HeaderLength;
	DWORD	TagStart;
	DWORD	TagEnd;
	DWORD	FileSize;
	
	MD3BONEFRAME	*BoneFrames;
	MD3TAG			*Tags;
	MD3MESH		*Meshes;
	//M3DMESH *Meshes;

private:
	int	 ReadHeader();
	FILE *MD3Stream;
};
