#include <windows.h>
#include <d3d8.h>
#include <d3dx8.h>
#include "md3load.h"

struct SVERTEX	//prelit vertex structure
{
	float x, y, z;
	DWORD dwColor;
	float tu, tv;
};

#define FVF_SVERTEX D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1

class CSKYDOME
{
public:
	CSKYDOME();
	~CSKYDOME();
	bool bIsDome;
	bool CSKYDOME::Init(float width, float height, IDirect3DDevice8 *lpDevice, char *SkyDomePath, char *cSBTexPath, int SBTexWidth, int SBTexHeight);
	bool Draw(IDirect3DDevice8 *lpDevice);
	inline float Rand2Seed(int a, int b);
	SVERTEX FillVertex(float x, float y, float z, DWORD dwColor, float tu, float tv);
	IDirect3DTexture8 *CreateCloudTexture(IDirect3DDevice8 *lpDevice);
	IDirect3DTexture8 *CreateNoiseTexture(int tsize, IDirect3DDevice8 *lpDevice);
	bool AnimateClouds(IDirect3DDevice8 *lpDevice);

	IDirect3DTexture8 *lpFrontTex, *lpBackTex, *lpTopTex, *lpBottomTex, *lpLeftTex, *lpRightTex, *DomeTex;
	IDirect3DTexture8 *lpOct128, *lpOct64, *lpOct32, *lpOct16, *lpCloudTex, *lpCloudZBuff;
	IDirect3DVertexBuffer8 *lpBlendQuadVB;
	IDirect3DVertexBuffer8 *lpSkyBoxVB, *lpSkyDomeVB;
	IDirect3DIndexBuffer8 *lpSkyDomeIB;
	IDirect3DSurface8		*lpCloudZBuffSurf;

	bool AnimFlip;
	float AnimCloudPos;

	int DomeNumVerts, DomeNumTriangles;

	CMD3FILE *md3Dome;
};