#include <windows.h>
#include <d3d8.h>
#include <d3dx8.h>

#ifndef BMPFONT
#include "bmpfont.h"
#endif


#define MAXROWS 24
#define MAXCOLS 128

//program specific commands
#define CONCOMM_HIDEFPS			101
#define CONCOMM_SHOWFPS			102
#define CONCOMM_WATERDETAILLOW	103
#define CONCOMM_WATERDETAILMED	104
#define CONCOMM_WATERDETAILHIGH	105

class CD3DCONSOLE
{
private:
	FILE				*OutputStream;

	int numRows, numCols;

	char				*ConOutput;
	char				*InputBuffer;
	char				Buffer[50];
	int					InputPos;			
	char				Cmd;
	char				Value;
	bool				Active;
	char				Prev;
	long				TransTime;
	bool				bTransIn, bTransOut;
	BYTE				ConAlpha;

public:
	CD3DCONSOLE();
	~CD3DCONSOLE();

	CBMPFONT			*Font;

	bool Init(char *BmpFontName, char *BgImage, WORD FontColor, char *OutputFileName, IDirect3DDevice8 *lpDevice);

	bool SetBgImage(IDirect3DTexture8 *BgTex);

	bool ConOutHasChanged;
	bool Draw(IDirect3DDevice8 *lpDevice);
	int  Input(char *in);
	int  Execute();

	bool ScrollUp(char *Feedback);

	bool IsActive;

	bool SendText(char *text);
	int ProcessCommand();
	void ClearInputLine();
	void ClearOutput();
	bool Activate(bool bTrans);
	bool Deactivate(bool bTrans);

	IDirect3DTexture8	*lpBgTex;
};


