#include "demo.h"
#include "skydome.h"

//controls the camera, and events, such as the volcano exploding

CDEMO::CDEMO()
{
	bPlayExplosion = false;
	KeyPress = false;
	VolYPos = 0.0f;
	bVolShakeUp = false;
	bMouseLook = false;
	bRumbleHasPlayed = false;
	bExplosionHasPlayed = false;
	bFireSoundHasPlayed = false;
	vPos.x = vPos.y = vPos.z = 0.0f;
	LavaSScale = 0;
}

CDEMO::~CDEMO()
{
	delete FireSmoke;
	lpVolLavaTex->Release();
	lpFlowingLavaTex->Release();
	lpLavaStream->Release();
	lpFireBBVB->Release();
	delete VolFire;
}

bool CDEMO::Init(CTIMER *Timer, CBMPFONT *Font, CEXPLOSION *Explosion, CPARTICLESYSTEM *PartSys, CTERRAIN *Volcano,  CDAUDIO *DAudio, IDirect3DDevice8 *lpDevice)
{
	pTimer = Timer;
	pFont = Font;
	pExplosion = Explosion;
	pPartSys = PartSys;
	pVolcano = Volcano;
	pDAudio = DAudio;
	HRESULT hRet;

	vPos.x = 2.24f;
	vPos.y = 11.69f;
	vPos.z = -12.27f;

	D3DXMatrixIdentity(&wMat);
	D3DXMatrixIdentity(&matOrientation);

	D3DXCreateTextureFromFile(lpDevice, "textures\\volcanotex.bmp", &lpTerrTex);

	D3DXCreateTextureFromFile(lpDevice, "textures\\lava.bmp", &lpVolLavaTex);	//change smoke particles to exploding lava

	D3DXCreateTextureFromFile(lpDevice, "textures\\lavastream.bmp", &lpLavaStream);

	lpDevice->CreateTexture(256, 256, 1, D3DUSAGE_RENDERTARGET, D3DFMT_R5G6B5, D3DPOOL_DEFAULT, &lpFlowingLavaTex);

	lpDevice->CreateVertexBuffer(sizeof(TERRAINVERTEX) * 6, D3DUSAGE_WRITEONLY, FVF_TERRAINVERTEX, D3DPOOL_DEFAULT, &lpFireBBVB);
	TERRAINVERTEX *pVert;
	hRet = lpFireBBVB->Lock(0, 0, (BYTE**)&pVert, NULL);
	if(hRet != D3D_OK)
	{
		MsgBox("Error Creating Fire Billboards", "Error", NULL, true);
		return false;
	}
	pVert[2].x = -1.0f; pVert[2].y = -1.0f; pVert[2].z = 0.0f; pVert[2].dwColor = D3DCOLOR_RGBA(255, 255, 255, 255); pVert[2].tu = 0.0f; pVert[2].tv = 1.0f;
	pVert[1].x = -1.0f; pVert[1].y = 1.0f; pVert[1].z = 0.0f; pVert[1].dwColor = D3DCOLOR_RGBA(255, 255, 255, 255); pVert[1].tu = 0.0f; pVert[1].tv = 0.0f;
	pVert[0].x = 1.0f; pVert[0].y = -1.0f; pVert[0].z = 0.0f; pVert[0].dwColor = D3DCOLOR_RGBA(255, 255, 255, 255); pVert[0].tu = 1.0f; pVert[0].tv = 1.0f;
	pVert[5].x = 1.0f; pVert[5].y = -1.0f; pVert[5].z = 0.0f; pVert[5].dwColor = D3DCOLOR_RGBA(255, 255, 255, 255); pVert[5].tu = 1.0f; pVert[5].tv = 1.0f;
	pVert[4].x = -1.0f; pVert[4].y = 1.0f; pVert[4].z = 0.0f; pVert[4].dwColor = D3DCOLOR_RGBA(255, 255, 255, 255); pVert[4].tu = 0.0f; pVert[4].tv = 0.0f;
	pVert[3].x = 1.0f; pVert[3].y = 1.0f; pVert[3].z = 0.0f; pVert[3].dwColor = D3DCOLOR_RGBA(255, 255, 255, 255); pVert[3].tu = 1.0f; pVert[3].tv = 0.0f;
	lpFireBBVB->Unlock();

	lpLavaQuadVB = lpFireBBVB;

	VolFire = new CFIRE();
	if(!VolFire->Init(16, "misc\\firepal.bmp", 3 , 10, 26, true, lpDevice))
		return false;

	FireSmoke = new CPARTICLESYSTEM();
	if(!FireSmoke->Init(lpDevice, "textures\\smoke.bmp", 4, 8, D3DXVECTOR3(0.0f, 1.5f, 0.0f), 1.0f, D3DXVECTOR3( -0.5f , 1.0f, -0.5f), D3DXVECTOR3(0.5f, 1.0f, 0.5f)))
		return false;
	





	return true;
}

bool CDEMO::PlayDemo(IDirect3DDevice8 *lpDevice)
{
	bool DemoPlaying;
	D3DVIEWPORT8 ViewPort;
	lpDevice->GetViewport(&ViewPort);

	if(pTimer->fElapsedTime < 5.0f)
	{
		PosVec.x = 10.73f;
		PosVec.y = 1.7f;
		PosVec.z = -17.45f;

		FocusVec.x = 9.0f;
		FocusVec.y = 0.0f;
		FocusVec.z = 0.0f;

		pFont->print("Water", ((ViewPort.Width / 2) - (40 * (5 / 2))), (ViewPort.Height / 2.0f) * -1, 5.0f, lpDevice);
	
		DemoPlaying = true;
	}
	if(pTimer->fElapsedTime >= 5.0f && pTimer->fElapsedTime < 12.0f)
	{
		FocusVec.y += (1.0f * pTimer->fTime);
		DemoPlaying = true;
	}
	if(pTimer->fElapsedTime >= 12.0f && pTimer->fElapsedTime < 18.0f)
	{
		pFont->print("Wind", ((ViewPort.Width / 2) - (40 * (5 / 2))), (ViewPort.Height / 2.0f) * -1, 5.0f, lpDevice);
		DemoPlaying = true;
	}
	if(pTimer->fElapsedTime >= 18.0f && pTimer->fElapsedTime < 25.0f)
	{
		FocusVec.x -= (1.2f * pTimer->fTime);
		DemoPlaying = true;
	}
	if(pTimer->fElapsedTime >= 25.0f && pTimer->fElapsedTime < 30.0f)
	{
		pFont->print("Earth", ((ViewPort.Width / 2) - (40 * (5 / 2))), (ViewPort.Height / 2.0f) * -1, 5.0f, lpDevice);
		DemoPlaying = true;
	}
	if(pTimer->fElapsedTime >= 30.0f && pTimer->fElapsedTime < 35.0f)
	{
		PosVec.x -= (1.7f * pTimer->fTime);
		PosVec.z += (1.037f * pTimer->fTime);
		PosVec.y += (2.0f * pTimer->fTime);
		DemoPlaying = true;
	}
	if(pTimer->fElapsedTime >= 35.0f)
	{
		pFont->print("Press Any Key", ((ViewPort.Width / 2) - (40 * (13 / 2))), ((ViewPort.Height / 2.0f) * -1) + 40.0f, 5.0f, lpDevice);
		pFont->print("To See Fire!", ((ViewPort.Width / 2) - (40 * (12 / 2))), ((ViewPort.Height / 2.0f) * -1) - 40.0f, 5.0f, lpDevice);
		if(KeyPress)
		{
			bPlayExplosion = true;
			fExplosionStartTime = pTimer->fElapsedTime;
		}

		DemoPlaying = true;
	}


	if(DemoPlaying)
	{
		D3DXMatrixLookAtLH(&vMat, &D3DXVECTOR3(PosVec.x, PosVec.y, PosVec.z), &D3DXVECTOR3(FocusVec.x, FocusVec.y, FocusVec.z), &D3DXVECTOR3(0.0f, 1.0f, 0.0f));
		return true;
	}
	else
		return false;
}

bool CDEMO::PlayExplosion(IDirect3DDevice8 *lpDevice)
{
	D3DVIEWPORT8 ViewPort;
	lpDevice->GetViewport(&ViewPort);
	if(pTimer->fElapsedTime <= fExplosionStartTime + 2.0f)
	{
		if(!bRumbleHasPlayed)
		{
			bRumbleHasPlayed = true;
			pDAudio->ChangeVolume("rumble", -800);
			pDAudio->Play("rumble", false);
		}

		switch(bVolShakeUp)
		{
		case true:
			VolYPos += 2.5f * pTimer->fTime;
			if(VolYPos >= 0.05f)
				bVolShakeUp = false;
			break;
		case false:
			VolYPos -= 2.5f * pTimer->fTime;
			if(VolYPos <= -0.05f)
				bVolShakeUp = true;
			break;
		}
	}
		
		
	if(pTimer->fElapsedTime > fExplosionStartTime + 2.0f)
	{
		if(!bExplosionHasPlayed)
		{
			bExplosionHasPlayed = true;
			pDAudio->ChangeVolume("rumble", 0);
			pDAudio->Play("explosion", false);
		}
		pPartSys->lpPartTex = lpVolLavaTex;
		pPartSys->PartDir1 = D3DXVECTOR3( -1.5f , 1.0f, -1.5f);
		pPartSys->PartDir2 = D3DXVECTOR3(1.5f, 1.0f, 1.5f);
		pExplosion->Draw(lpDevice, pTimer->dTime);
		DrawFlowingLava(lpLavaQuadVB, pTimer->fTime, lpDevice);
	}
		
	if(pTimer->fElapsedTime > fExplosionStartTime + 6.5f && pTimer->fElapsedTime < fExplosionStartTime + 14.0f)
	{
		bool bDrawFire;
		if(pTimer->fElapsedTime > fExplosionStartTime + 14.0f)
			bDrawFire = false;
		else
			bDrawFire = true;

		if(!bFireSoundHasPlayed)
		{
			pDAudio->Play("fire", true);
			pDAudio->ChangeVolume("fire", -9600);
			bFireSoundHasPlayed = true;
		}

		FireSmoke->Update(pTimer->dTime, 1);
		
		D3DXMATRIX transmat, scalemat, firewmat;
		DWORD OldAlphaBlendEnable, OldSrcBlend, OldDestBlend;
		if(bDrawFire)
			VolFire->Burn();

		lpDevice->SetTexture(0, VolFire->FireTex);
		lpDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
		lpDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_SELECTARG1);
		lpDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE);
		lpDevice->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1);

		lpDevice->GetRenderState(D3DRS_ALPHABLENDENABLE, &OldAlphaBlendEnable);
		lpDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);

		lpDevice->GetRenderState(D3DRS_SRCBLEND, &OldSrcBlend);
		lpDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
		lpDevice->GetRenderState(D3DRS_DESTBLEND, &OldDestBlend);
		lpDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);

		lpDevice->SetStreamSource(0, lpFireBBVB, sizeof(TERRAINVERTEX));
		lpDevice->SetVertexShader(FVF_TERRAINVERTEX);
		D3DXMatrixTranslation(&transmat, 1.5f, 7.0f, -2.0f);
		D3DXMatrixScaling(&scalemat, 0.3f, 0.3f, 0.3f);
		D3DXMatrixMultiply(&firewmat, &scalemat, &transmat);
		lpDevice->SetTransform(D3DTS_WORLD, &firewmat);
		if(bDrawFire)
			lpDevice->DrawPrimitive(D3DPT_TRIANGLELIST, 0, 2);
		FireSmoke->Render(lpDevice);


		lpDevice->SetTexture(0, VolFire->FireTex);
		lpDevice->SetStreamSource(0, lpFireBBVB, sizeof(TERRAINVERTEX));
		lpDevice->SetVertexShader(FVF_TERRAINVERTEX);
		D3DXMatrixTranslation(&transmat, 0.95f, 5.26f, -2.0f);
		D3DXMatrixScaling(&scalemat, 0.3f, 0.3f, 0.3f);
		D3DXMatrixMultiply(&firewmat, &scalemat, &transmat);
		lpDevice->SetTransform(D3DTS_WORLD, &firewmat);
		if(bDrawFire)
			lpDevice->DrawPrimitive(D3DPT_TRIANGLELIST, 0, 2);
		FireSmoke->Render(lpDevice);

		lpDevice->SetTexture(0, VolFire->FireTex);
		lpDevice->SetStreamSource(0, lpFireBBVB, sizeof(TERRAINVERTEX));
		lpDevice->SetVertexShader(FVF_TERRAINVERTEX);
		D3DXMatrixTranslation(&transmat, 0.1f, 6.5f, -2.0f);
		D3DXMatrixScaling(&scalemat, 0.3f, 0.3f, 0.3f);
		D3DXMatrixMultiply(&firewmat, &scalemat, &transmat);
		lpDevice->SetTransform(D3DTS_WORLD, &firewmat);
		if(bDrawFire)
			lpDevice->DrawPrimitive(D3DPT_TRIANGLELIST, 0, 2);
		FireSmoke->Render(lpDevice);

		lpDevice->SetTexture(0, VolFire->FireTex);
		lpDevice->SetStreamSource(0, lpFireBBVB, sizeof(TERRAINVERTEX));
		lpDevice->SetVertexShader(FVF_TERRAINVERTEX);
		D3DXMatrixTranslation(&transmat, 0.75f, 6.0f, -2.0f);
		D3DXMatrixScaling(&scalemat, 0.3f, 0.3f, 0.3f);
		D3DXMatrixMultiply(&firewmat, &scalemat, &transmat);
		lpDevice->SetTransform(D3DTS_WORLD, &firewmat);
		if(bDrawFire)
			lpDevice->DrawPrimitive(D3DPT_TRIANGLELIST, 0, 2);
		FireSmoke->Render(lpDevice);

		lpDevice->SetTexture(0, VolFire->FireTex);
		lpDevice->SetStreamSource(0, lpFireBBVB, sizeof(TERRAINVERTEX));
		lpDevice->SetVertexShader(FVF_TERRAINVERTEX);
		D3DXMatrixTranslation(&transmat, 0.0f, 4.70f, -2.0f);
		D3DXMatrixScaling(&scalemat, 0.3f, 0.3f, 0.3f);
		D3DXMatrixMultiply(&firewmat, &scalemat, &transmat);
		lpDevice->SetTransform(D3DTS_WORLD, &firewmat);
		if(bDrawFire)
			lpDevice->DrawPrimitive(D3DPT_TRIANGLELIST, 0, 2);
		FireSmoke->Render(lpDevice);

		lpDevice->GetRenderState(D3DRS_ALPHABLENDENABLE, &OldAlphaBlendEnable);
		lpDevice->SetRenderState(D3DRS_DESTBLEND, OldDestBlend);
		lpDevice->SetRenderState(D3DRS_SRCBLEND, OldSrcBlend);

		

	}

	if(pTimer->fElapsedTime > fExplosionStartTime + 6.5f && pTimer->fElapsedTime < fExplosionStartTime + 10.0f)
		pFont->print("Fire", ((ViewPort.Width / 2) - (40 * (4 / 2))), (ViewPort.Height / 2.0f) * -1, 5.0f, lpDevice);
	if(pTimer->fElapsedTime > fExplosionStartTime + 10.0f && pTimer->fElapsedTime < fExplosionStartTime + 14.0f)
	{
		pFont->print("Use The Mouse/Arrow", ((ViewPort.Width / 2) - (40 * (19 / 2))), ((ViewPort.Height / 2.0f) * -1) + 40.0f, 5.0f, lpDevice);
		pFont->print("To Explore", ((ViewPort.Width / 2) - (40 * (10 / 2))), ((ViewPort.Height / 2.0f) * -1) - 40.0f, 5.0f, lpDevice);
	}
	if(pTimer->fElapsedTime > fExplosionStartTime + 14.0f)
		bMouseLook = true;
		

	D3DXMatrixTranslation(&wMat, 0.0f, VolYPos, 0.0f);
	//pFont->print("Fire", ((ViewPort.Width / 2) - (40 * (5 / 2))), (ViewPort.Height / 2.0f) * -1, 5.0f, lpDevice);
	return true;
}

bool CDEMO::DrawFlowingLava(IDirect3DVertexBuffer8 *QuadVB, float fTime, IDirect3DDevice8 *lpDevice)
{
	HRESULT hRet;
	D3DXMATRIX worldMat, viewMat, projMat, OldWorldMat, OldViewMat, OldProjMat;
	IDirect3DSurface8  *VolTexSurf, *OldZBuffer, *OldRenderTarget;

	DWORD OldAlphaBlendEnable, OldSrcBlend, OldDestBlend;

	lpDevice->GetTransform(D3DTS_PROJECTION, &OldProjMat);
	lpDevice->GetTransform(D3DTS_WORLD, &OldWorldMat);
	lpDevice->GetTransform(D3DTS_VIEW, &OldViewMat);

	lpDevice->GetDepthStencilSurface(&OldZBuffer);
	lpDevice->GetRenderTarget(&OldRenderTarget);

	lpFlowingLavaTex->GetSurfaceLevel(0, &VolTexSurf);

	hRet = lpDevice->SetRenderTarget(VolTexSurf, NULL);
	if(hRet != D3D_OK)
	{
		return false;
	}
	lpDevice->SetRenderState(D3DRS_ZENABLE, D3DZB_FALSE);

	D3DXMatrixIdentity(&worldMat);
	lpDevice->SetTransform(D3DTS_WORLD, &worldMat);
	D3DXMatrixIdentity(&viewMat);
	lpDevice->SetTransform(D3DTS_VIEW, &viewMat);
	
	D3DXMatrixOrthoLH(&projMat, 2, 2, -1, 1);
	lpDevice->SetTransform(D3DTS_PROJECTION, &projMat);

	lpDevice->Clear(0, NULL, D3DCLEAR_TARGET, D3DCOLOR_RGBA(0, 0, 0, 0), 1.0f, 0);

	lpDevice->BeginScene();	//we are going to begin drawing polys

	hRet = lpDevice->SetTexture(0, lpTerrTex);
	hRet = lpDevice->SetVertexShader(FVF_TERRAINVERTEX);
	hRet = lpDevice->SetStreamSource(0, QuadVB, sizeof(TERRAINVERTEX));
	hRet = lpDevice->DrawPrimitive(D3DPT_TRIANGLELIST, 0, 2);
	if(hRet != D3D_OK)
		return false;


	lpDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	lpDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_SELECTARG1);
	lpDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE);
	lpDevice->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1);

	lpDevice->GetRenderState(D3DRS_ALPHABLENDENABLE, &OldAlphaBlendEnable);
	lpDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);

	lpDevice->GetRenderState(D3DRS_SRCBLEND, &OldSrcBlend);
	lpDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
	lpDevice->GetRenderState(D3DRS_DESTBLEND, &OldDestBlend);
	lpDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);

	if(LavaSScale <= 5.0f)
		LavaSScale += (0.25f * fTime);

	D3DXMatrixScaling(&worldMat, LavaSScale, LavaSScale, 1.0f);	//make lava look as if its flowing out
	lpDevice->SetTransform(D3DTS_WORLD, &worldMat);

	hRet = lpDevice->SetTexture(0, lpLavaStream);
	hRet = lpDevice->SetVertexShader(FVF_TERRAINVERTEX);
	hRet = lpDevice->SetStreamSource(0, QuadVB, sizeof(TERRAINVERTEX));
	hRet = lpDevice->DrawPrimitive(D3DPT_TRIANGLELIST, 0, 2);
	if(hRet != D3D_OK)
		return false;

	
	lpDevice->EndScene();	///we are done drawing polys

	lpDevice->SetRenderTarget(OldRenderTarget, OldZBuffer);
	lpDevice->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
	lpDevice->SetRenderState(D3DRS_SRCBLEND, OldSrcBlend);
	lpDevice->SetRenderState(D3DRS_DESTBLEND, OldDestBlend);
	lpDevice->SetTransform(D3DTS_PROJECTION, &OldProjMat);
	lpDevice->SetTransform(D3DTS_WORLD, &OldWorldMat);
	lpDevice->SetTransform(D3DTS_VIEW, &OldViewMat);

	pVolcano->lpTerrTex = lpFlowingLavaTex;

	return true;
	
}

void CDEMO::MouseLook(D3DXVECTOR3 *vT, float ViewRotX, float ViewRotY)
{
	//mouselook setup
			
	D3DXVec3TransformNormal( vT, vT, &matOrientation );
	PosVec += *vT;

	if(PosVec.x >= 15.0f)
		PosVec.x = 15.0f;

	if(PosVec.x <= -15.0f)
		PosVec.x = -15.0f;

	if(PosVec.z >= 15.0f)
		PosVec.z = 15.0f;

	if(PosVec.z <= -15.0f)
		PosVec.z = -15.0f;

	if(PosVec.y >= 12.0f)
		PosVec.y = 12.0f;

	if(PosVec.y <= 1.7f)
		PosVec.y = 1.7f;

	vT->x = 0.0f;
	vT->y = 0.0f;
	vT->z = 0.0f;
	
	D3DXQUATERNION qR;
	D3DXQuaternionRotationYawPitchRoll(&qR, ViewRotX, ViewRotY, 0.0f);
	D3DXMatrixAffineTransformation(&matOrientation, 1.25f, NULL, &qR, &PosVec);
	D3DXMatrixInverse( &vMat, NULL, &matOrientation );
}