#include <d3d8.h>
#include <d3dx8.h>
#include "miscfuncs.h"
#include "explosion.h"
#include "fire.h"
#include "terrain.h"
#include "daudio.h"

class CDEMO
{
public:
	CDEMO();
	~CDEMO();
	bool PlayDemo();
	D3DXMATRIX	vMat;
	D3DXMATRIX	wMat;
	CTIMER		*pTimer;
	CBMPFONT	*pFont;
	CEXPLOSION	*pExplosion;
	CPARTICLESYSTEM	*pPartSys;
	CPARTICLESYSTEM	*FireSmoke;
	CTERRAIN        *pVolcano;
	CDAUDIO			*pDAudio;
	IDirect3DTexture8 *lpTerrTex;
	D3DXVECTOR3	PosVec, FocusVec;
	bool		KeyPress, bPlayExplosion, bVolShakeUp;
	bool		PlayDemo(IDirect3DDevice8 *lpDevice);
	bool		PlayExplosion(IDirect3DDevice8 *lpDevice);
	bool		Init(CTIMER *Timer, CBMPFONT *Font, CEXPLOSION *Explosion, CPARTICLESYSTEM *PartSys, CTERRAIN *Volcano, CDAUDIO *DAudio, IDirect3DDevice8 *lpDevice);
	bool		DrawFlowingLava(IDirect3DVertexBuffer8 *QuadVB, float fTime, IDirect3DDevice8 *lpDevice);
	bool		bMouseLook;
	bool		bRumbleHasPlayed, bExplosionHasPlayed, bFireSoundHasPlayed;
	float		fExplosionStartTime, VolYPos;
	float		LavaSScale;
	D3DXMATRIX	matOrientation;
	D3DXVECTOR3 vPos;
	void		MouseLook(D3DXVECTOR3 *vT, float ViewRotX, float ViewRotY);
	IDirect3DTexture8	*lpVolLavaTex;
	IDirect3DTexture8	*lpFlowingLavaTex;
	IDirect3DTexture8	*lpLavaStream;
	IDirect3DVertexBuffer8	*lpFireBBVB;
	IDirect3DVertexBuffer8  *lpLavaQuadVB;
	CFIRE					*VolFire;
	
};