#include <windows.h>
#include <d3d8.h>
#include <d3dx8.h>

#ifndef INCL_PARTICLEH
#define NUMPARTS 500
#define FVF_PARTICLE (D3DFVF_XYZ | D3DFVF_PSIZE | D3DFVF_DIFFUSE)

struct PARTVERT
{
	float x, y, z;
	float Size;
	DWORD dwColor;
};

class CPARTICLE
{
public:
	bool IsActive; 

	CPARTICLE();
	~CPARTICLE();
	
	float fSize;
	float fLifeTime;
	float fAge;

	float  Alpha;
	DWORD dwColor;
	DWORD dwColorStep;

	D3DXVECTOR3 Pos;
	D3DXVECTOR3 Dir;

	void Init(float fPartSize, float fPartLifeTime, D3DXVECTOR3 vecPos, D3DXVECTOR3 vecDir, DWORD dwPartColor);
	inline bool Update(float DeltaTime, float PartSpeed);
};

class CPARTICLESYSTEM
{
public:
	~CPARTICLESYSTEM();
	CPARTICLESYSTEM();

	int MinEmitRate;
	int MaxEmitRate;
	int numActiveParts;

	float LeftOverParts;
	float PartSpeed;

	bool Init(IDirect3DDevice8 *lpDevice, char * TexFilePath, int MinER, int MaxER, D3DXVECTOR3 Pos, float PartSpeed, D3DXVECTOR3 vecPartDir1, D3DXVECTOR3 vecPartDir2);
	bool Draw(IDirect3DDevice8 *lpDevice);
	bool Update(DWORD DeltaTime, bool bCreateNewParts);
	bool Render(IDirect3DDevice8 *lpDevice);

	IDirect3DTexture8		*lpPartTex;
	IDirect3DVertexBuffer8	*lpPartVertBuff;

	D3DXVECTOR3 PartDir1;
	D3DXVECTOR3 PartDir2;
	D3DXVECTOR3	OriginPos;

	CPARTICLE *Particles;
};

#define INCL_PARTICLEH
#endif
