#include <windows.h>
#include <d3d8.h>
#include <d3dx8.h>
#include <stdio.h>

#define FVF_WATERVERTEX (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1)

struct WATERVERTEX
{
	float x, y, z;
	DWORD dwColor;
	float tu, tv;
};

struct WATERELEMENT
{
	float MaxX, MaxY, MaxZ, MinX, MinY, MinZ;
	float CurX, CurY, CurZ;
	bool bXInc, bYInc, bZInc;
};
	

class CWATER
{
public:
	CWATER();
	~CWATER();
	bool Init(char *cWaterTexPath, DWORD dwWaterColor, float YPos, int WaterWidth, int WaterLength, int VertDensityX, int VertDensityZ, float XRnge, float YRnge, float ZRnge, IDirect3DDevice8* lpDevice);
	bool Draw(IDirect3DDevice8 *lpDevice, DWORD dwTime);
	bool Update(DWORD dwTime);

	WATERELEMENT	*Elements;


//private:
	bool CreateHVertexGrid(IDirect3DVertexBuffer8 **lpGVB, IDirect3DIndexBuffer8 **lpGIB, float WaterYPos, int VertsX,int VertsZ, int XSize, int ZSize, DWORD dwVertColor, IDirect3DDevice8 *lpDevice);

	int NumVertsX;
	int NumVertsZ;

	float XRange, YRange, ZRange;

	float fRandNum(float fMin, float fMax);

	IDirect3DVertexBuffer8	*lpWaterVB;
	IDirect3DIndexBuffer8	*lpWaterIB;
	IDirect3DTexture8		*lpWaterTex;
};
